//-----------------------------------------------------------
//
//-----------------------------------------------------------
class BikePassenger extends ONSWeaponPawn;

// BoneRotations for Setting up look of Driving Cycle
var rotator ArmDriveL,ArmDriveR;
Var rotator NeckDrive;
Var rotator ThighDriveL,ThighDriveR;
Var rotator CalfDriveL,CalfDriveR;

simulated function AttachDriver(Pawn P)
{
    super.AttachDriver(P);

   //Set Bones so Driver Looks Like its Riding a Cycle
    //Head
    NeckDrive.Yaw=-10000;
    P.SetBoneRotation('Bip01 Head',NeckDrive);
    //Arms
    //LeftArm
    ArmDriveL.Yaw=-5000;
    ArmDriveL.Pitch=-2500;
    P.SetBoneRotation('Bip01 L UpperArm',ArmDriveL);
    //RightArm
    ArmDriveR.Yaw=-5000;
    ArmDriveR.Pitch=2500;
    P.SetBoneRotation('Bip01 R UpperArm',ArmDriveR);
      //Thighs
      //Left Thigh
    ThighDriveL.Pitch=-10000;
    P.SetBoneRotation('Bip01 L Thigh',ThighDriveL);
    //Right Thigh
    ThighDriveR.Pitch=10000;
    P.SetBoneRotation('Bip01 R Thigh',ThighDriveR);
     //Calfs
     //Left Calf
    CalfDriveL.Pitch=6500;
    CalfDriveL.Yaw=-6500;
    P.SetBoneRotation('Bip01 L Calf',CalfDriveL);
    //Right Calf
    CalfDriveR.Pitch=-6500;
    CalfDriveR.Yaw=-6500;
    P.SetBoneRotation('Bip01 R Calf',CalfDriveR);

	//P.DrawScale=P.Default.DrawScale *
}
function bool KDriverLeave(bool bForceLeave)
{

   //Return Bones back to good Position
   //Head
    Driver.SetBoneRotation('Bip01 Head');
    //Arms
    //LeftArm
    Driver.SetBoneRotation('Bip01 L UpperArm');
    //RightArm
    Driver.SetBoneRotation('Bip01 R UpperArm');
    //Thighs
    //Left Thigh
    Driver.SetBoneRotation('Bip01 L Thigh');
    //Right Thigh
    Driver.SetBoneRotation('Bip01 R Thigh');
    //Calfs
    //Left Calf
    Driver.SetBoneRotation('Bip01 L Calf');
    //Right Calf
    Driver.SetBoneRotation('Bip01 R Calf');
    Super.KDriverLeave(True);
    return True;
}


defaultproperties
{
     DriveRot=(Pitch=-10000)
     GunClass=Class'BattleBikes.BikePassAttachment'
     ExitPositions(0)=(Y=165.000000,Z=100.000000)
     ExitPositions(1)=(Y=-165.000000,Z=100.000000)
     ExitPositions(2)=(Y=165.000000,Z=-100.000000)
     ExitPositions(3)=(Y=-165.000000,Z=-100.000000)
     EntryPosition=(X=40.000000,Y=50.000000,Z=-100.000000)
     EntryRadius=170.000000
     FPCamPos=(Z=20.000000)
     TPCamDistance=500.000000
     TPCamLookat=(X=-100.000000,Z=50.000000)
     DriverDamageMult=0.400000
     DrivePos=(X=10.000000,Z=10.000000)
     VehiclePositionString="On a Bike"
     VehicleNameString="Bike Passenger"
}
