//-----------------------------------------------------------
//
//-----------------------------------------------------------
class DualRocket extends Projectile;

#exec OBJ LOAD FILE=..\Sounds\VMVehicleSounds-S.uax

// FX
var Emitter			TrailEmitter;
var class<Emitter>	TrailClass;


var Effects Corona;
var int NumExtraRockets;





var vector Dir;
var	Actor		CurrentTarget;
var float			HomingAggressivity;
var	float			HomingCheckFrequency, HomingCheckCount;
var sound  	IgniteSound;
var sound 	FlightSound;
var bool bSmall;
replication
{


	reliable if (bNetDirty && Role == ROLE_Authority)
		CurrentTarget;
}


simulated function Destroyed()
{
     if ( TrailEmitter != None )
		TrailEmitter.Destroy();

	if ( Corona != None )
		Corona.Destroy();
	Super.Destroyed();
}

simulated function PostBeginPlay()
{
   	Super.PostBeginPlay();
}

simulated function PostNetBeginPlay()
{

	Super.PostNetBeginPlay();

	Dir = Vector(Rotation);
    Velocity = Dir * Speed;


	   SetTimer(0.33, false);


}

simulated function Landed( vector HitNormal )
{
	Explode(Location,HitNormal);
}

simulated function ProcessTouch (Actor Other, Vector HitLocation)
{
	if ( (Other != instigator) && (!Other.IsA('Projectile') || Other.bProjTarget) )
		Explode(HitLocation, vector(rotation)*-1 );
}

function BlowUp(vector HitLocation)
{
	HurtRadius(Damage, DamageRadius, MyDamageType, MomentumTransfer, HitLocation );
	MakeNoise(1.0);
}

simulated function Explode(vector HitLocation, vector HitNormal)
{
	local PlayerController PC;

	PlaySound(sound'WeaponSounds.BExplosion3',,2.5*TransientSoundVolume);
    if ( EffectIsRelevant(Location,false) )
    {
    	Spawn(class'NewExplosionA',,,HitLocation + HitNormal*20,rotator(HitNormal));
    	PC = Level.GetLocalPlayerController();
		if ( (PC.ViewTarget != None) && VSize(PC.ViewTarget.Location - Location) < 5000 )
	        Spawn(class'ExplosionCrap',,, HitLocation + HitNormal*20, rotator(HitNormal));
//		if ( (ExplosionDecal != None) && (Level.NetMode != NM_DedicatedServer) )
//			Spawn(ExplosionDecal,self,,Location, rotator(-HitNormal));
    }

	BlowUp(HitLocation);
	Destroy();
}

simulated function Timer()
{
      SpawnTrail();
	 Velocity = Speed * Dir;
	if (CurrentTarget!=none)
	    gotoState('Homing');
	else
        gotoState('Flying');

}

simulated function SpawnTrail()
{
    if (TrailEmitter!=none)
       return;
   TrailEmitter = Spawn(TrailClass,,, Location, Rotation);
if ( Level.NetMode != NM_DedicatedServer)
	{
	 Corona = Spawn(class'RocketCorona',self);
	}

    TrailEmitter = Spawn(TrailClass,,, Location, Rotation);

    if ( TrailEmitter == None )
        return;

	TrailEmitter.SetBase( Self );


			Spawn(class'MissileIgnite',,,location,rotation);

         PlaySound(IgniteSound, SLOT_Misc, 255, true, 512);
		AmbientSound = FlightSound;

}

state Flying
{
    simulated function Timer()
   {

    Velocity = Speed * Dir;
  }


	simulated function Tick(float DeltaTime)
	{
		// Increase Speed progressively
		Speed		+= 2000.f * DeltaTime;
		Acceleration = vector(Rotation) * Speed;
	}

	simulated function Landed( vector HitNormal )
	{
		Explode(Location,HitNormal);
	}


	function BlowUp(vector HitLocation)
	{
		HurtRadius(Damage, DamageRadius, MyDamageType, MomentumTransfer, Location );
		MakeNoise(1.0);
	}
	simulated function ProcessTouch (Actor Other, Vector HitLocation)
     {
	if ( (Other != instigator) && (!Other.IsA('Projectile') || Other.bProjTarget) )
		Explode(HitLocation, vector(rotation)*-1 );
     }
}

state Homing
{
	simulated function Tick(float DeltaTime)
	{

		// Increase Speed progressively
		Speed		+= 1000.f * DeltaTime;
		Acceleration = vector(Rotation) * Speed;
	}
    simulated function Timer()
	{
	    local vector ForceDir;
	    local float VelMag;

	    if ( Dir == vect(0,0,0) )
	        Dir = Normal(Velocity);

		Acceleration = vect(0,0,0);
	    Super.Timer();
	    if (CurrentTarget!=none)
	    	// do normal guidance to target.
		ForceDir = Normal(CurrentTarget.Location - Location);
		if( (ForceDir dot Dir) > 0 )
		{
			VelMag = VSize(Velocity);

			// track vehicles better
			ForceDir = Normal(ForceDir * 0.5 * VelMag + Velocity);
			Velocity =  VelMag * ForceDir;
			Acceleration += 5 * ForceDir;
		}
		// Update rocket so it faces in the direction its going.
		SetRotation(rotator(Velocity));
	}

	simulated function BeginState()
	{
	    SetTimer(0.1, true);
	}
	simulated function Landed( vector HitNormal )
	{
		Explode(Location,HitNormal);
	}


	function BlowUp(vector HitLocation)
	{
		HurtRadius(Damage, DamageRadius, MyDamageType, MomentumTransfer, Location );
		MakeNoise(1.0);
	}
	simulated function ProcessTouch (Actor Other, Vector HitLocation)
     {
	if ( (Other != instigator) && (!Other.IsA('Projectile') || Other.bProjTarget) )
		Explode(HitLocation, vector(rotation)*-1 );
     }
}

defaultproperties
{
     TrailClass=OnslaughtBP.ONSDualMissileSmokeTrail

     HomingAggressivity=0.250000
     HomingCheckFrequency=0.067000

     IgniteSound=Sound'CicadaSnds.Missile.MissileIgnite'
     FlightSound=Sound'CicadaSnds.Missile.MissileFlight'
     Speed=3000.000000
     MaxSpeed=5500.000000
     Damage=125.000000
     DamageRadius=250.000000
     MomentumTransfer=50000.000000
     MyDamageType=Class'BattleBikes.DamTypeDuelRocket'
     ExplosionDecal=Class'Onslaught.ONSRocketScorch'
     DrawType=DT_StaticMesh
     StaticMesh=VMWeaponsSM.AVRiLGroup.AVRiLprojectileSM
     AmbientSound=VMVehicleSounds-S.HoverTank.IncomingShell
     LifeSpan=7.000000
     DrawScale=0.050000
     AmbientGlow=96
     FluidSurfaceShootStrengthMod=10.000000
     SoundVolume=255
     SoundRadius=256.000000
     bFixedRotationDir=True
     RotationRate=(Roll=50000)
     DesiredRotation=(Roll=900000)
     ForceType=FT_Constant
     ForceRadius=100.000000
     ForceScale=5.000000
}
