//=============================================================================
// MutAdvancedArmor
//
//=============================================================================
class MutBattleBikes extends Mutator config(BattleBikes);

var config bool bWeapon_BikeSpawnRifle;
var localized string bSpawnRifle_AutoText,bSpawnRifle_DescText;
var config bool bTranslocator;
var localized string HaveTranslocatorDesc;

var string ArenaVehicleClassNameA,ArenaDescTextA;		// Your vehicle class
var string ArenaVehicleClassNameB,ArenaDescTextB;


var config string FactoryVehicleClassNameA;	// The default vehicle to replace
var config string FactoryVehicleClassNameB;


var class<SVehicle> ArenaVehicleClassA,ArenaVehicleClassB;
var class<SVehicle> FactoryVehicleClassA,FactoryVehicleClassB;

var localized string ArenaDisplayTextA;		// The line that shows up in the config menu (ie: "Replace this vehicle with the Flak Scorpion")
var localized string ArenaDisplayTextB;

function PostBeginPlay()
{
	local ONSVehicleFactory FactoryA,FactoryB;

    if ( Level.Game.Level.Game.bAllowVehicles==false)
        Level.Game.Level.Game.bAllowVehicles=true;

	FactoryVehicleClassA = class<SVehicle>( DynamicLoadObject(FactoryVehicleClassNameA,class'Class') );
	FactoryVehicleClassB = class<SVehicle>( DynamicLoadObject(FactoryVehicleClassNameB,class'Class') );
	ArenaVehicleClassA = class<SVehicle>( DynamicLoadObject(ArenaVehicleClassNameA,class'Class') );
    ArenaVehicleClassB = class<SVehicle>( DynamicLoadObject(ArenaVehicleClassNameB,class'Class') );

    if(ArenaVehicleClassA != None)
	{
		foreach AllActors( class 'ONSVehicleFactory', FactoryA )
		{
			if (FactoryA.VehicleClass == FactoryVehicleClassA)
				FactoryA.VehicleClass = ArenaVehicleClassA;
		}
	}
   if(ArenaVehicleClassB != None)
	{
		foreach AllActors( class 'ONSVehicleFactory', FactoryB )
		{
			if (FactoryB.VehicleClass == FactoryVehicleClassB)
				FactoryB.VehicleClass = ArenaVehicleClassB;
		}
	}

	Super.PostBeginPlay();
}

static function FillPlayInfo(PlayInfo PlayInfo)
{
	local array<CacheManager.VehicleRecord> Recs;
	local string VehicleOptions;
	local int i;
	local class<SVehicle> v;

	Super.FillPlayInfo(PlayInfo);

	class'CacheManager'.static.GetVehicleList(Recs);
    VehicleOptions = ";";

	for (i = 0; i < Recs.Length; i++)
	{
		v = class<SVehicle>(DynamicLoadObject(Recs[i].ClassName, class'class', false));
		if (v != None)
			VehicleOptions $= ";" $ Recs[i].ClassName $ ";" $ Recs[i].FriendlyName;
	}

	PlayInfo.AddSetting(default.RulesGroup, "FactoryVehicleClassNameA", default.ArenaDisplayTextA, 0, 1, "Select", VehicleOptions);
    PlayInfo.AddSetting(default.RulesGroup, "FactoryVehicleClassNameB", default.ArenaDisplayTextB, 0, 1, "Select", VehicleOptions);
      //Spawn Rifle Info
    PlayInfo.AddSetting(default.RulesGroup, "bWeapon_BikeSpawnRifle", default.bSpawnRifle_AutoText, 0, 1, "Check");
    PlayInfo.AddSetting(default.RulesGroup, "bTranslocator", default.HaveTranslocatorDesc, 0, 1, "Check");

    return;
}


static event string GetDescriptionText(string PropName)
{
	if (PropName == "FactoryVehicleClassNameA")
		return default.ArenaDescTextA;
    if (PropName == "FactoryVehicleClassNameB")
		return default.ArenaDescTextB;
        //SpawnRifles
	 if (PropName == "bWeapon_BikeSpawnRifle")
		return default.bSpawnRifle_DescText;
	return Super.GetDescriptionText(PropName);
}
//------------------------------------------------------------------------------
function ModifyPlayer(Pawn Other)
{
  	// call the parent class
	Super.ModifyPlayer(Other);

	if  ((level.Game.bTeamGame==false)||(level.Game.bTeamGame==true))
       {

         if (bWeapon_BikeSpawnRifle)
             Other.CreateInventory("BattleBikes.BikeSpawnRifle");


         if (bTranslocator)
	         Other.CreateInventory("XWeapons.TransLauncher");

      }


	if ( NextMutator != None )
		 NextMutator.ModifyPlayer(Other);
}


defaultproperties
{
    HaveTranslocatorDesc="All GameTypes TransLocator"

     bSpawnRifle_AutoText="Start With a Bike Spawn Rifle."
     bSpawnRifle_DescText="All Players Spawn With a Bike Spawn Rifle."
     bWeapon_BikeSpawnRifle=True
     bTranslocator=True
     FactoryVehicleClassNameA="Onslaught.ONSHoverBike"
     FactoryVehicleClassNameB="Onslaught.ONSRV"
     ArenaVehicleClassNameA="BattleBikes.FragEdSpecial"
     ArenaVehicleClassNameB="BattleBikes.WyvernBike"
     ArenaDisplayTextA="Replace this with the FragEdSpecial:"
     ArenaDescTextA="Replace any vehicle with the FragEdSpecial."
     ArenaDisplayTextB="Replace this with the WyvernBike:"
     ArenaDescTextB="Replace any vehicle with the WyvernBike."
     GroupName="Battle Bikes Mutator"
     FriendlyName="Battle Bikes Mutator"
     Description="Ride Armed MotorCycles Jump, do flips, 180's and 360,s. Replace any Vehicle with Armed Motorcycles. Give Players MotorCycle Spawn Gun, To Adjust Bike Options Load BattleBikes Bike Configuration Mutators."

}


