//=============================================================================
// MutAdvancedArmor
//
//=============================================================================
class MutBattleBikes_BikeConfig extends Mutator;


//FragEdSpecial Configs
var config float FragEdSpecialHealth;
var localized string FragEdSpecialHealthText, FragEdSpecialHealthDescText;

var config float  FragEdSpecialJumpThrustAmount;
var localized string FragEdSpecialJumpThrustAmountTxt, FragEdSpecialJumpThrustAmountDescTxt;
//Wyvern Weapon Types
var config bool bFragEd_Cannon;
var localized string bFragEd_Cannon_Text,bFragEd_Cannon_DescText;

var config bool bFragEd_PulseGun;
var localized string bFragEd_PulseGun_Text,bFragEd_PulseGun_DescText;

var config bool bFragEd_GatGun;
var localized string bFragEd_GatGun_Text,bFragEd_GatGun_DescText;

var config bool bFragEd_ShockGun;
var localized string bFragEd_ShockGun_Text,bFragEd_ShockGun_DescText;

var config bool bFragEd_IonGun;
var localized string bFragEd_IonGun_Text,bFragEd_IonGun_DescText;

//WyvernBike Configs
var config float WyvernBikeHealth;
var localized string WyvernBikeHealthText, WyvernBikeHealthDescText;

var config float  WyvernBikeJumpThrustAmount;
var localized string WyvernBikeJumpThrustAmountTxt, WyvernBikeJumpThrustAmountDescTxt;
//Wyvern Weapon Types
var config bool bWyvern_Cannon;
var localized string bWyvern_Cannon_Text,bWyvern_Cannon_DescText;

var config bool bWyvern_PulseGun;
var localized string bWyvern_PulseGun_Text,bWyvern_PulseGun_DescText;

var config bool bWyvern_GatGun;
var localized string bWyvern_GatGun_Text,bWyvern_GatGun_DescText;

var config bool bWyvern_ShockGun;
var localized string bWyvern_ShockGun_Text,bWyvern_ShockGun_DescText;

var config bool bWyvern_IonGun;
var localized string bWyvern_IonGun_Text,bWyvern_IonGun_DescText;

function PostBeginPlay()
{
	local ONS_WyvernBikeFactory ONSWFactory;
	local VCTF_WyvernBikeFactory VWFactory;
	local ONS_FragEdSpecialFactory ONSFFactory;
	local VCTF_FragEdSpecialFactory VFFactory;
    	foreach AllActors( class 'ONS_WyvernBikeFactory', ONSWFactory )
		{
			if (bWyvern_Cannon)
				ONSWFactory.WeaponClass = Class'W_BikeCannonGun';

            if (bWyvern_GatGun)
				ONSWFactory.WeaponClass = Class'W_BikeGatGun';

            if (bWyvern_IonGun)
				ONSWFactory.WeaponClass = Class'W_BikeIonPlasma_Weapon';

            if (bWyvern_PulseGun)
				ONSWFactory.WeaponClass = Class'W_BikePulseGun';

            if (bWyvern_ShockGun)
				ONSWFactory.WeaponClass = Class'W_SkyMineGun';
		}

        foreach AllActors( class 'VCTF_WyvernBikeFactory', VWFactory )
		{
			if (bWyvern_Cannon)
				VWFactory.WeaponClass = Class'W_BikeCannonGun';

            if (bWyvern_GatGun)
				VWFactory.WeaponClass = Class'W_BikeGatGun';

            if (bWyvern_IonGun)
				VWFactory.WeaponClass = Class'W_BikeIonPlasma_Weapon';

            if (bWyvern_PulseGun)
				VWFactory.WeaponClass = Class'W_BikePulseGun';

            if (bWyvern_ShockGun)
				VWFactory.WeaponClass = Class'W_SkyMineGun';
		}

       foreach AllActors( class 'ONS_FragEdSpecialFactory', ONSFFactory )
		{
			if (bFragEd_Cannon)
				ONSFFactory.WeaponClass = Class'F_BikeCannonGun';

            if (bFragEd_GatGun)
				ONSFFactory.WeaponClass = Class'F_BikeGatGun';

            if (bFragEd_IonGun)
				ONSFFactory.WeaponClass = Class'F_BikeIonPlasma_Weapon';

            if (bFragEd_PulseGun)
				ONSFFactory.WeaponClass = Class'F_BikePulseGun';

            if (bFragEd_ShockGun)
				ONSFFactory.WeaponClass = Class'F_SkyMineGun';
		}

        foreach AllActors( class 'VCTF_FragEdSpecialFactory', VFFactory )
		{
			if (bFragEd_Cannon)
				VFFactory.WeaponClass = Class'F_BikeCannonGun';

            if (bFragEd_GatGun)
				VFFactory.WeaponClass = Class'F_BikeGatGun';

            if (bFragEd_IonGun)
				VFFactory.WeaponClass = Class'F_BikeIonPlasma_Weapon';

            if (bFragEd_PulseGun)
				VFFactory.WeaponClass = Class'F_BikePulseGun';

            if (bFragEd_ShockGun)
				VFFactory.WeaponClass = Class'F_SkyMineGun';
		}

    Super.PostBeginPlay();
}

static function FillPlayInfo(PlayInfo PlayInfo)
{
	Super.FillPlayInfo(PlayInfo);

	//FragEdSpecial Settings
    PlayInfo.AddSetting(default.RulesGroup, "FragEdSpecialHealth", default.FragEdSpecialHealthText, 0, 1, "Text", "4;150:8000");
    PlayInfo.AddSetting(default.RulesGroup, "FragEdSpecialJumpThrustAmount", default.FragEdSpecialJumpThrustAmountTxt, 0, 1, "Text", "4;1600:6000");
    //FragEdSpecial Weapon Types
    PlayInfo.AddSetting(default.RulesGroup, "bFragEd_Cannon", default.bFragEd_Cannon_Text, 0, 1, "Check");
    PlayInfo.AddSetting(default.RulesGroup, "bFragEd_GatGun", default.bFragEd_GatGun_Text, 0, 1, "Check");
    PlayInfo.AddSetting(default.RulesGroup, "bFragEd_IonGun", default.bFragEd_IonGun_Text, 0, 1, "Check");
    PlayInfo.AddSetting(default.RulesGroup, "bFragEd_PulseGun", default.bFragEd_PulseGun_Text, 0, 1, "Check");
    PlayInfo.AddSetting(default.RulesGroup, "bFragEd_ShockGun", default.bFragEd_ShockGun_Text, 0, 1, "Check");

    //WyvernBike Settings
    PlayInfo.AddSetting(default.RulesGroup, "WyvernBikeHealth", default.WyvernBikeHealthText, 0, 1, "Text", "4;150:8000");
    PlayInfo.AddSetting(default.RulesGroup, "WyvernBikeJumpThrustAmount", default.WyvernBikeJumpThrustAmountTxt, 0, 1, "Text", "4;1500:4000");
    //WyvernBike Weapon Types
    PlayInfo.AddSetting(default.RulesGroup, "bWyvern_Cannon", default.bWyvern_Cannon_Text, 0, 1, "Check");
    PlayInfo.AddSetting(default.RulesGroup, "bWyvern_GatGun", default.bWyvern_GatGun_Text, 0, 1, "Check");
    PlayInfo.AddSetting(default.RulesGroup, "bWyvern_IonGun", default.bWyvern_IonGun_Text, 0, 1, "Check");
    PlayInfo.AddSetting(default.RulesGroup, "bWyvern_PulseGun", default.bWyvern_PulseGun_Text, 0, 1, "Check");
    PlayInfo.AddSetting(default.RulesGroup, "bWyvern_ShockGun", default.bWyvern_ShockGun_Text, 0, 1, "Check");

    return;
}


static event string GetDescriptionText(string PropName)
{
	//WyvernBike
    if (PropName == "FragEdSpecialHealth")
		return default.FragEdSpecialHealthDescText;

    if (PropName == "FragEdSpecialJumpThrustAmount")
		return default.FragEdSpecialJumpThrustAmountDescTxt;
	//WyvernBike Weapons
	if (PropName == "bFragEd_Cannon")
		return default.bFragEd_Cannon_DescText;

    if (PropName == "bFragEd_GatGun")
		return default.bFragEd_GatGun_DescText;

    if (PropName == "bFragEd_IonGun")
		return default.bFragEd_IonGun_DescText;

    if (PropName == "bFragEd_PulseGun")
		return default.bFragEd_PulseGun_DescText;

	if (PropName == "bFragEd_ShockGun")
		return default.bFragEd_ShockGun_DescText;

	//WyvernBike
    if (PropName == "WyvernBikeHealth")
		return default.WyvernBikeHealthDescText;

    if (PropName == "WyvernBikeJumpThrustAmount")
		return default.WyvernBikeJumpThrustAmountDescTxt;
	//WyvernBike Weapons
	if (PropName == "bWyvern_Cannon")
		return default.bWyvern_Cannon_DescText;

    if (PropName == "bWyvern_GatGun")
		return default.bWyvern_GatGun_DescText;

    if (PropName == "bWyvern_IonGun")
		return default.bWyvern_IonGun_DescText;

    if (PropName == "bWyvern_PulseGun")
		return default.bWyvern_PulseGun_DescText;

	if (PropName == "bWyvern_ShockGun")
		return default.bWyvern_ShockGun_DescText;

	return Super.GetDescriptionText(PropName);
}

function bool CheckReplacement(Actor Other, out byte bSuperRelevant)
{
	bSuperRelevant = 0;

    //FragEdSpecial
	if (Other.IsA('FragEdSpecial'))
	   {
        FragEdSpecial(Other).Health = FragEdSpecialHealth;
        FragEdSpecial(Other).BikeJumpForce = FragEdSpecialJumpThrustAmount;

        if(bFragEd_Cannon)
           FragEdSpecial(Other).BikeWeaponClass=Class'F_BikeCannonGun';

        if(bFragEd_GatGun)
           FragEdSpecial(Other).BikeWeaponClass=Class'F_BikeGatGun';

        if(bFragEd_IonGun)
           FragEdSpecial(Other).BikeWeaponClass=Class'F_BikeIonPlasma_Weapon';

        if(bFragEd_PulseGun)
           FragEdSpecial(Other).BikeWeaponClass=Class'F_BikePulseGun';

        if(bFragEd_ShockGun)
           FragEdSpecial(Other).BikeWeaponClass=Class'F_SkyMineGun';
       }



      //WyvernBike
	if (Other.IsA('WyvernBike'))
	   {
        WyvernBike(Other).Health = WyvernBikeHealth;
        WyvernBike(Other).BikeJumpForce = WyvernBikeJumpThrustAmount;

        if(bWyvern_Cannon)
           WyvernBike(Other).BikeWeaponClass=Class'W_BikeCannonGun';

        if(bWyvern_GatGun)
           WyvernBike(Other).BikeWeaponClass=Class'W_BikeGatGun';

        if(bWyvern_IonGun)
           WyvernBike(Other).BikeWeaponClass=Class'W_BikeIonPlasma_Weapon';

        if(bWyvern_PulseGun)
           WyvernBike(Other).BikeWeaponClass=Class'W_BikePulseGun';

        if(bWyvern_ShockGun)
           WyvernBike(Other).BikeWeaponClass=Class'W_SkyMineGun';
       }


	return true;

	Super.CheckReplacement(Other, bSuperRelevant);
}

defaultproperties
{
     GroupName="BattleBikes Bike Configuration"
     FriendlyName="BattleBikes Bike Configuration"
     Description="Configure Parts of MotorCycle Jump amount, Health, and Weapon Type."
     //FragEdSpecial Configs
     FragEdSpecialHealthText="FragEdSpecial Health"
     FragEdSpecialHealthDescText="FragEdSpecial Health"
     FragEdSpecialJumpThrustAmountTxt="FragEdSpecial Jump Thrust Amount"
     FragEdSpecialJumpThrustAmountDescTxt="Amount of Thrust applied to bike when jumping."
     //Weapons
     bFragEd_Cannon_Text="FragEdSpecial Cannon:"
     bFragEd_Cannon_DescText="Replaces all FragEdSpecial MotorCycles Weapon With Cannon and Rockets."
     bFragEd_GatGun_Text="FragEdSpecial Gatling Gun:"
     bFragEd_GatGun_DescText="Replaces all FragEdSpecial MotorCycles Weapon With Gatling gun and Rockets."
     bFragEd_IonGun_Text="FragEdSpecial IonCannon:"
     bFragEd_IonGun_DescText="Replaces all FragEdSpecial MotorCycles Weapon With IonCannon and Shields."
     bFragEd_PulseGun_Text="FragEdSpecial Pulse Gun:"
     bFragEd_PulseGun_DescText="Replaces all FragEdSpecial MotorCycles Weapon With Pulse Gun and Rockets."
     bFragEd_ShockGun_Text="FragEdSpecial Shock Cannon:"
     bFragEd_ShockGun_DescText="Replaces all FragEdSpecial MotorCycles Weapon With Shock cannon (Like HellBender ShockCannon)."
     //WyvernBike Configs
     WyvernBikeHealthText="WyvernBike Health"
     WyvernBikeHealthDescText="WyvernBike Health"
     WyvernBikeJumpThrustAmountTxt="WyvernBike Jump Thrust Amount"
     WyvernBikeJumpThrustAmountDescTxt="Amount of Thrust applied to bike when jumping."
     //Weapons
     bWyvern_Cannon_Text="Wyvern Cannon:"
     bWyvern_Cannon_DescText="Replaces all Wyvern MotorCycles Weapon With Cannon and Rockets."
     bWyvern_GatGun_Text="Wyvern Gatling Gun:"
     bWyvern_GatGun_DescText="Replaces all Wyvern MotorCycles Weapon With Gatling gun and Rockets."
     bWyvern_IonGun_Text="Wyvern IonCannon:"
     bWyvern_IonGun_DescText="Replaces all Wyvern MotorCycles Weapon With IonCannon and Shields."
     bWyvern_PulseGun_Text="Wyvern Pulse Gun:"
     bWyvern_PulseGun_DescText="Replaces all Wyvern MotorCycles Weapon With Pulse Gun and Rockets."
     bWyvern_ShockGun_Text="Wyvern Shock Cannon:"
     bWyvern_ShockGun_DescText="Replaces all Wyvern MotorCycles Weapon With Shock cannon (Like HellBender ShockCannon)."
}

