//-----------------------------------------------------------
//
//-----------------------------------------------------------
class ONS_WyvernBikeFactory extends ONSVehicleFactory;


var WyvernBike Bike;
var() class <WyvernBike_Weapons> WeaponClass;
var() bool bChangeBikeWeapon;
function SpawnVehicle()
{
	local Pawn P;
	local bool bBlocked;

    foreach CollidingActors(class'Pawn', P, VehicleClass.default.CollisionRadius * 1.25)
	{
		bBlocked = true;
		if (PlayerController(P.Controller) != None)
			PlayerController(P.Controller).ReceiveLocalizedMessage(class'ONSOnslaughtMessage', 11);
	}

    if (bBlocked)
    	SetTimer(1, false); //try again later
    else
    {
        if (bReverseBlueTeamDirection && ONSOnslaughtGame(Level.Game) != None && ((TeamNum == 1 && !ONSOnslaughtGame(Level.Game).bSidesAreSwitched) || (TeamNum == 0 && ONSOnslaughtGame(Level.Game).bSidesAreSwitched)))
            Bike = spawn(class'WyvernBike',,, Location, Rotation + rot(0,32768,0));
        else
            Bike = spawn(class'WyvernBike',,, Location, Rotation);

		if (Bike != None )
		{
			VehicleCount++;
			Bike.BikeWeaponClass= WeaponClass;
			if(bChangeBikeWeapon==true)
            Bike.NewWeapon();
			Bike.SetTeamNum(TeamNum);
			Bike.Event = Tag;
			Bike.ParentFactory = Self;
		}
    }
}

defaultproperties
{
     RedBuildEffectClass=Class'Onslaught.ONSRVBuildEffectRed'
     BlueBuildEffectClass=Class'Onslaught.ONSRVBuildEffectBlue'
     Mesh=SkeletalMesh'BattleBikes_Anim.WyvernMesh'
     DrawScale=0.6
     VehicleClass=Class'BattleBikes.WyvernBike'
}
