//-----------------------------------------------------------
// DualACSideGun
//
// This is the primary weapon the Frag Ed Special.
//-----------------------------------------------------------
class F_BikePulseGun extends FragEdSpecialBike_Weapons;

var class<Projectile> TeamProjectileClasses[2];
var float MinAim;
var float MaxLockRange, LockAim;

//AI: return the best fire mode for the situation
function byte BestMode()
{
	if ( (Instigator.Controller == None) || (Instigator.Controller.Target == None) )
		return 1;
	if ( (Pawn(Instigator.Controller.Target) != None) && !Pawn(Instigator.Controller.Target).bStationary && (Instigator.Controller.Focus == Instigator.Controller.Target) )
		return 0;
	return 1;
}


state ProjectileFireMode
{
	function Fire(Controller C)
	{
		FlashMuzzleFlash();
        if (Vehicle(Owner) != None && Vehicle(Owner).Team < 2)
			ProjectileClass = TeamProjectileClasses[Vehicle(Owner).Team];
		else
			ProjectileClass = TeamProjectileClasses[0];

		Super.Fire(C);
	}

    function AltFire(Controller C)
	{
		local DualRocket P;
		local float BestAim, BestDist;

		P = DualRocket(SpawnProjectile(AltFireProjectileClass, True));


		if (P != None)
		{
			if (AIController(C) != None)
			     P.CurrentTarget = C.Enemy;

			else
			   {
				BestAim = LockAim;
				P.CurrentTarget = C.PickTarget(BestAim, BestDist, vector(WeaponFireRotation), WeaponFireLocation, MaxLockRange);
  		       }
        }


	}

}
defaultproperties
{
     TeamProjectileClasses(0)=Class'BattleBikes.PROJ_BLaserPulseRed'
     TeamProjectileClasses(1)=Class'BattleBikes.PROJ_BLaserPulseBlue'
     FlashEmitterClass=Class'Onslaught.ONSPRVSideGunMuzzleFlash'
     WeaponFireOffset=-15.000000
     LockAim=0.975000
     MinAim=0.925000
     FireInterval=0.25000
     MaxLockRange=16000.000000
     YawBone="RL_Right"
     YawStartConstraint=-18000.000000
     YawEndConstraint=18000.000000
     PitchBone="RL_Right"
     PitchUpLimit=18000
     PitchDownLimit=50000
     WeaponFireAttachmentBone="RightRLAttach"
     RotationsPerSecond=2.090000
     //bInstantRotation=True
     AltFireInterval=0.650000
     FireSoundClass=SoundGroup'WeaponSounds.PulseRifle.PulseRifleFire'
     FireSoundVolume=70.000000
     AltFireSoundClass=Sound'CicadaSnds.Missile.MissileEject'
     AltFireSoundVolume=70.000000
     ProjectileClass=Class'BattleBikes.PROJ_BLaserPulseRed'
     AltFireProjectileClass=Class'BattleBikes.DualRocket'
     AIInfo(0)=(bTrySplash=True,bLeadTarget=True,WarnTargetPct=0.500000,RefireRate=0.990000)
     AIInfo(1)=(bTrySplash=True,WarnTargetPct=0.200000,RefireRate=0.990000)
     CullDistance=7000.000000
     Mesh=SkeletalMesh'BattleBikes_Anim.BikeSideRocketMesh'
     DrawScale=0.25
}
