//=============================================================================
// MutAdvancedArmor
//
//=============================================================================
class MutBattleBikesWyvernBike extends Mutator;

//WyvernBike Configs
var config float WyvernBikeHealth;
var localized string WyvernBikeHealthText, WyvernBikeHealthDescText;

var config float  WyvernBikeJumpThrustAmount;
var localized string WyvernBikeJumpThrustAmountTxt, WyvernBikeJumpThrustAmountDescTxt;
//Wyvern Weapon Types
var config bool bWyvern_Cannon;
var localized string bWyvern_Cannon_Text,bWyvern_Cannon_DescText;

var config bool bWyvern_PulseGun;
var localized string bWyvern_PulseGun_Text,bWyvern_PulseGun_DescText;

var config bool bWyvern_GatGun;
var localized string bWyvern_GatGun_Text,bWyvern_GatGun_DescText;

var config bool bWyvern_ShockGun;
var localized string bWyvern_ShockGun_Text,bWyvern_ShockGun_DescText;

var config bool bWyvern_IonGun;
var localized string bWyvern_IonGun_Text,bWyvern_IonGun_DescText;

function PostBeginPlay()
{
	Super.PostBeginPlay();
}

static function FillPlayInfo(PlayInfo PlayInfo)
{
	Super.FillPlayInfo(PlayInfo);

	//WyvernBike Settings
    PlayInfo.AddSetting(default.RulesGroup, "WyvernBikeHealth", default.WyvernBikeHealthText, 0, 1, "Text", "4;150:8000");
    PlayInfo.AddSetting(default.RulesGroup, "WyvernBikeJumpThrustAmount", default.WyvernBikeJumpThrustAmountTxt, 0, 1, "Text", "4;1500:4000");
    //WyvernBike Weapon Types
    PlayInfo.AddSetting(default.RulesGroup, "bWyvern_Cannon", default.bWyvern_Cannon_Text, 0, 1, "Check");
    PlayInfo.AddSetting(default.RulesGroup, "bWyvern_GatGun", default.bWyvern_GatGun_Text, 0, 1, "Check");
    PlayInfo.AddSetting(default.RulesGroup, "bWyvern_IonGun", default.bWyvern_IonGun_Text, 0, 1, "Check");
    PlayInfo.AddSetting(default.RulesGroup, "bWyvern_PulseGun", default.bWyvern_PulseGun_Text, 0, 1, "Check");
    PlayInfo.AddSetting(default.RulesGroup, "bWyvern_ShockGun", default.bWyvern_ShockGun_Text, 0, 1, "Check");

    return;
}


static event string GetDescriptionText(string PropName)
{
	//WyvernBike
    if (PropName == "WyvernBikeHealth")
		return default.WyvernBikeHealthDescText;

    if (PropName == "WyvernBikeJumpThrustAmount")
		return default.WyvernBikeJumpThrustAmountDescTxt;
	//WyvernBike Weapons
	if (PropName == "bWyvern_Cannon")
		return default.bWyvern_Cannon_DescText;

    if (PropName == "bWyvern_GatGun")
		return default.bWyvern_GatGun_DescText;

    if (PropName == "bWyvern_IonGun")
		return default.bWyvern_IonGun_DescText;

    if (PropName == "bWyvern_PulseGun")
		return default.bWyvern_PulseGun_DescText;

	if (PropName == "bWyvern_ShockGun")
		return default.bWyvern_ShockGun_DescText;

	return Super.GetDescriptionText(PropName);
}

function bool CheckReplacement(Actor Other, out byte bSuperRelevant)
{
	bSuperRelevant = 0;

    //WyvernBike
	if (Other.IsA('WyvernBike'))
	   {
        WyvernBike(Other).Health = WyvernBikeHealth;
        WyvernBike(Other).BikeJumpForce = WyvernBikeJumpThrustAmount;

        if(bWyvern_Cannon)
           WyvernBike(Other).BikeWeaponClass=Class'W_BikeCannonGun';

        if(bWyvern_GatGun)
           WyvernBike(Other).BikeWeaponClass=Class'W_BikeGatGun';

        if(bWyvern_IonGun)
           WyvernBike(Other).BikeWeaponClass=Class'W_BikeIonPlasma_Weapon';

        if(bWyvern_PulseGun)
           WyvernBike(Other).BikeWeaponClass=Class'W_BikePulseGun';

        if(bWyvern_ShockGun)
           WyvernBike(Other).BikeWeaponClass=Class'W_SkyMineGun';
       }
	return true;

	Super.CheckReplacement(Other, bSuperRelevant);
}

defaultproperties
{
     GroupName="BattleBikes Wyvern Bike"
     FriendlyName="BattleBikes Wyvern Bike"
     Description="Configure Parts of MotorCycle Jump amount, Health, and Weapon Type."
     //WyvernBike Configs
     WyvernBikeHealthText="WyvernBike Health"
     WyvernBikeHealthDescText="WyvernBike Health"
     WyvernBikeJumpThrustAmountTxt="WyvernBike Jump Thrust Amount"
     WyvernBikeJumpThrustAmountDescTxt="Amount of Thrust applied to bike when jumping."
     //Weapons
     bWyvern_Cannon_Text="Wyvern Cannon:"
     bWyvern_Cannon_DescText="Replaces all Wyvern MotorCycles Weapon With Cannon and Rockets."
     bWyvern_GatGun_Text="Wyvern Gatling Gun:"
     bWyvern_GatGun_DescText="Replaces all Wyvern MotorCycles Weapon With Gatling gun and Rockets."
     bWyvern_IonGun_Text="Wyvern IonCannon:"
     bWyvern_IonGun_DescText="Replaces all Wyvern MotorCycles Weapon With IonCannon and Shields."
     bWyvern_PulseGun_Text="Wyvern Pulse Gun:"
     bWyvern_PulseGun_DescText="Replaces all Wyvern MotorCycles Weapon With Pulse Gun and Rockets."
     bWyvern_ShockGun_Text="Wyvern Shock Cannon:"
     bWyvern_ShockGun_DescText="Replaces all Wyvern MotorCycles Weapon With Shock cannon (Like HellBender ShockCannon)."
}


